--[[To do:
Managment for special bags
Frame strata for inter layering?
Multiple slot counts
Keep cursor position
Sort by sub type aswell
Split sell and delete
Re-opening the bank quickly after closing it will not work
Account for non categorized items (Soul Shard is a reagent)
Clear cursor with map open
Special container learning capability
Close all / expand all
Remove all categories
Recognize disappearance of an item if a new enchanted item appears
List sorted / filtered indicator
Data transfer to other players
Fix multiple stack dragging
Blocking of regular bank box


SetCursor("Interface\\Icons\\INV_Scroll_03");
]]
local ItemList, DragItem, DragCategory, BankOpen, TradeOpen;
local SplitHoldItem, SplitHoldExpire, SplitPending, SplitTimeout, IgnoreHooks, CursorItem;
local SelectedSort, SelectedFilter, CustomFilter = {1,1}, {1,1}, {};
local DisplayNames = {"Inventory","Bank Box"};
local DisplayList = {};
--List will refresh on first OnUpdate
local QueuedUpdate = {true, true};
local TempSlotLock = {};
local ItemStringMatch = "(item[%d:]+:(%-?%d+)):(%-?%d+)|";
local CursorHover;

local FadeTime = 0.2;
local IndentSize = 10;

local Sorts = {
  {Name="No Sorting"},
  {Name="Alphabetical", Var=1},
  {Name="Rarity", Var=3}
};

--This is not used yet
local SpecialBags = {
--  ["SoulBag"] = {"SoulShard"},
  ["Quiver"] = {"Arrow"},
  ["Ammo Pouch"] = {"Bullet"},
  ["Toolbox"] = {"Parts","Devices","Explosives"}
};

BaudManifest_Debug = false;

local function DebugMsg(Msg)
  if BaudManifest_Debug then
    DEFAULT_CHAT_FRAME:AddMessage(Msg);
  end
end


function BaudManTest()
  tinsert(ItemList[1][1],{Category = 1});
  BaudManifestUpdateDisplayList(1);
end


StaticPopupDialogs["BAUDMANIFEST_DELETECATEGORY"] = {
  text = "Are you sure you want to delete this category?",
  button1 = TEXT(YES),
  button2 = TEXT(NO),
  OnAccept = function()
    BaudManifestDeleteDraggedCategory();
  end,
  OnCancel = function()
    DebugMsg("Cancel delete category.");
    BaudManifestClearDragCategory();
  end,
  timeout = 0,
  exclusive = 1,
  hideOnEscape = 1
};


StaticPopupDialogs["BAUDMANIFEST_CATEGORIZE"] = {
  text = "This action will put uncategorized items into categories based on their type.  Do you wish to proceed?",
  button1 = TEXT(YES),
  button2 = TEXT(NO),
  OnAccept = function(Display)
    BaudManifestCategorize(Display);
  end,
  timeout = 0,
  exclusive = 1,
  hideOnEscape = 1
};


function BaudManifest_OnLoad()
  SlashCmdList["BaudManifest"] = function()
    BaudManifestDisplay1:Show();
  end
  SLASH_BaudManifest1 = "/baudmanifest";
  SLASH_BaudManifest2 = "/baudman";
  BINDING_HEADER_BaudManifest = "Baud Manifest";
  BINDING_NAME_BaudManifest = "Open Manifest";
  this:RegisterEvent("VARIABLES_LOADED");
  this:RegisterEvent("BAG_UPDATE");
  this:RegisterEvent("UNIT_INVENTORY_CHANGED");
  this:RegisterEvent("BAG_CLOSED");
  this:RegisterEvent("BAG_UPDATE_COOLDOWN");
  this:RegisterEvent("PLAYERBANKSLOTS_CHANGED");
  this:RegisterEvent("BANKFRAME_OPENED");
  this:RegisterEvent("BANKFRAME_CLOSED");
  this:RegisterEvent("TRADE_SHOW");
  this:RegisterEvent("TRADE_CLOSED");
  this:RegisterEvent("CURSOR_UPDATE");
  this:RegisterEvent("ITEM_LOCK_CHANGED");
  DEFAULT_CHAT_FRAME:AddMessage("Baud Manifest: AddOn loaded. Type /baudmanifest to display your manifest.");

  for Bag = -1, 4 + NUM_BANKBAGSLOTS do
    CreateFrame("Frame","BaudManifestBag"..Bag,getglobal("BaudManifestDisplay"..(((Bag==-1)or(Bag > 4))and 2 or 1)),nil):SetID(Bag);
  end
end

local CursorItem;

function BaudManifest_OnEvent()
  if(event=="VARIABLES_LOADED")then
    if(type(BaudManifest_Cfg)~="table")then
      BaudManifest_Cfg = {};
    end
    if(type(BaudManifest_Cfg.Items)~="table")then
      BaudManifest_Cfg.Items = {};
    end
    ItemList = BaudManifest_Cfg.Items;
    for Display = 1, 2 do
      if(type(ItemList[Display])~="table")then
        ItemList[Display] = {};
      end
      if(type(ItemList[Display][1])~="table")then
        ItemList[Display][1] = {};

      --This is for backwards compatibility
      elseif ItemList[Display][1].ItemString then
        ChatFrame1:AddMessage("Baud Manifest: Converting variable structure #"..Display..".");
        local ItemIndex = 1;
        while ItemList[Display][ItemIndex]do
          if not ItemList[Display][ItemIndex].ItemString then
            tremove(ItemList[Display],ItemIndex);
          else
            ItemIndex = ItemIndex + 1;
          end
        end
        ItemList[Display] = {[1] = ItemList[Display]};
      end
    end

  elseif(event=="BAG_UPDATE")or(event=="BAG_CLOSED")or(event=="PLAYERBANKSLOTS_CHANGED")then
    --Updating of items done even if the bag is closed to keep the ordering correct
    local Display;
    if(event=="PLAYERBANKSLOTS_CHANGED")or(arg1==-1)or(arg1 > 4)then
      Display = 2;
    else
      Display = 1;
    end
    QueuedUpdate[Display] = true;
    if DragItem and DragItem.Pending and(DragItem.Origin==Display)then
      DragItem.Pending = 1;
    end

  elseif(event=="UNIT_INVENTORY_CHANGED")then
    if(arg1~="player")then
      return;
    end
    QueuedUpdate[1] = true;

  elseif(event=="ITEM_LOCK_CHANGED")then
    --The list is updated to change the specific targeted items, but only if the list is open
    for Display = 1, 2 do
      if getglobal("BaudManifestDisplay"..Display):IsShown()then
        QueuedUpdate[Display] = true;
      end
    end

  elseif(event=="BAG_UPDATE_COOLDOWN")then
    BaudManifestScrollBar_Update(1);

  elseif(event=="BANKFRAME_OPENED")then
    BankOpen = true;
    BaudManifestUpdateList(2);
    BaudManifestDisplay2:Show();

  elseif(event=="BANKFRAME_CLOSED")then
    BankOpen = false;
    BaudManifestDisplay2:Hide();

  elseif(event=="TRADE_SHOW")then
    TradeOpen = true;
    BaudManifestTradeRemain();

  elseif(event=="TRADE_CLOSED")then
    TradeOpen = false;

  elseif(event=="CURSOR_UPDATE")then
    if(CursorHasItem()~=CursorItem)then
      CursorItem = CursorHasItem();
      BaudManifestUpdateBlocked();
    end
  end
end


function BaudManifestCategoryEditBox_OnEditFocusLost()
  this:Hide();
  BaudManifestScrollBar_Update(this.Display);
end


function BaudManifestCategoryEditBox_OnTextChanged()
  --This function executes on load, before it is used
  if this.Display then
    ItemList[this.Display][this.Category].Name = this:GetText();
  end
end


function BaudManifestClearDragCategory()
  if not DragCategory then
    return;
  end
  DebugMsg("Clearing dragged category.");
  PlaySound("INTERFACESOUND_CURSORDROPOBJECT");
  DragCategory = nil;
  BaudManifestDragCategoryIcon:Hide();
  BaudManifestUpdateBlocked();
end


function BaudManifestDeleteDraggedCategory()
  if not DragCategory then
    DebugMsg("No category to delete.");
    return;
  end
  DebugMsg("Deleting category #"..DragCategory.Index);

  local Replace, ListIndex;
  for Category, ParentCat in ipairs(ItemList[DragCategory.Origin])do
    ListIndex = 1;
    while ParentCat[ListIndex]do
      if ParentCat[ListIndex].Category then
        if(ParentCat[ListIndex].Category==DragCategory.Index)then
          DebugMsg("Located category listing, removing and replacing it with its contents.");
          --Removing table elements while cycling through them can mess things up, but this loop breaks so it doesn't matter
          tremove(ParentCat, ListIndex);
          ListIndex = ListIndex - 1;
          --Now replace the deleted category with its contents
          if not Replace then
            Replace = true;
            for Key, Value in ipairs(ItemList[DragCategory.Origin][DragCategory.Index])do
              --Make sure the copies entries are skipped, or categories could be decremented twice
              ListIndex = ListIndex + 1;
              tinsert(ParentCat,ListIndex,Value);
            end
          end
        elseif(ParentCat[ListIndex].Category > DragCategory.Index)then
          ParentCat[ListIndex].Category = ParentCat[ListIndex].Category - 1;
        end
      end
      ListIndex = ListIndex + 1;
    end
  end
  DebugMsg("Deleting category variable.");
  tremove(ItemList[DragCategory.Origin],DragCategory.Index);
  BaudManifestUpdateDisplayList(DragCategory.Origin);
  BaudManifestClearDragCategory();
end


function BaudManifestOptionsDropDown_OnLoad()
  UIDropDownMenu_Initialize(this, BaudManifestOptionsDropDown_Initialize, "MENU");
end


function BaudManifestOptionsDropDown_Initialize()
  local info = UIDropDownMenu_CreateInfo();

  if(UIDROPDOWNMENU_MENU_VALUE==1)and not BaudManifestDisplay2:IsShown()then
    info.text = "Show Bank";
    info.func = function()
      BaudManifestDisplay2:Show();
    end
    UIDropDownMenu_AddButton(info);
  end

  info.text = "Create Category";
  info.func = BaudManifestGetCategory;
  info.arg1 = UIDROPDOWNMENU_MENU_VALUE;
  UIDropDownMenu_AddButton(info);

  info.text = "Categorize By Type";
  info.func = function(Display)
    if BaudManifestCategoriesDisabled(Display)then
      UIErrorsFrame:AddMessage("Cannot create categories while the list is sorted or filtered.", 1.0, 0.1, 0.1, 1.0, UIERRORS_HOLD_TIME);
      return;
    end
    local Dialog = StaticPopup_Show("BAUDMANIFEST_CATEGORIZE");
    if Dialog then
      Dialog.data = Display;
    end
  end
  UIDropDownMenu_AddButton(info);
end


function BaudManifestCategoriesDisabled(Display)
  return (SelectedSort[Display]~=1)or(SelectedFilter[Display]~=1)or strfind(CustomFilter[Display]or "","[^%s]");
end


function BaudManifestCategorize(Display)
  DebugMsg("Categorizing loose items");
  local Type, SubType, Category, New;
  local Index = 1;
  while(ItemList[Display][1][Index])do
    if ItemList[Display][1][Index].ItemString then
      _, _, _, _, _, Type, SubType = GetItemInfo(ItemList[Display][1][Index].ItemString);
      if not Type then
        Index = Index + 1;
      else
        Category, New = BaudManifestGetCategory(Display, Type, 1);
        if New then
          Index = Index + 1;
        end
        --[[if SubType and(SubType~=Type)then
          Category = BaudManifestGetCategory(Display, SubType, Category);
        end]]
        tinsert(ItemList[Display][Category],ItemList[Display][1][Index]);
        tremove(ItemList[Display][1],Index);
      end
    else
      Index = Index + 1;
    end
  end
  BaudManifestUpdateDisplayList(Display);
end


--First argument is the only one required
function BaudManifestGetCategory(Display, Name, ParentCategory)
  if BaudManifestCategoriesDisabled(Display)then
    UIErrorsFrame:AddMessage("Cannot create categories while the list is sorted or filtered.", 1.0, 0.1, 0.1, 1.0, UIERRORS_HOLD_TIME);
    return;
  end
  if ParentCategory then
    for Key, Value in ipairs(ItemList[Display][ParentCategory])do
      if Value.Category and(ItemList[Display][Value.Category].Name==Name)then
        return Value.Category;
      end
    end
  end
  if not Name then
    Name = "New Category";
  end
  DebugMsg("Creating category: "..Name);
  tinsert(ItemList[Display],{Name=Name, Expanded=false});
  local Category = getn(ItemList[Display]);
  tinsert(ItemList[Display][(ParentCategory or 1)],1,{Category = Category});
  FauxScrollFrame_SetOffset(getglobal("BaudManifestDisplay"..Display.."ScrollBar"),0);
  if not ParentCategory then
    BaudManifestUpdateDisplayList(Display);
  end
  return Category, true;
end


function BaudManifestOptionsButton_OnClick()
  ToggleDropDownMenu(1, this:GetParent():GetID(), BaudManifestOptionsDropDown, this:GetName(), 0, 0);
end


function BaudManifestUpdateBlocked()
  --Enabling and disabling item entries to serve this purpose will prevent items from being dropped by releasing the cursor
  local Enable = CursorItem or DragCategory;
  for Display = 1, 2 do
    local Frame = getglobal("BaudManifestDisplay"..Display.."ClickBlock");
    if Enable then
      Frame:Show();
    else
      Frame:Hide();
    end
  end
  DebugMsg("Click block "..(Enable and "Enabled." or "Disabled."));
end


hooksecurefunc("PickupContainerItem",function(Bag,Slot)
  if IgnoreHooks or DragItem or not CursorHasItem()then
    return;
  end
  DragItem = GetContainerItemLink(Bag, Slot);
  if not DragItem then
    return;
  end
  DragItem = string.match(DragItem, ItemStringMatch);
  if not DragItem then
    return;
  end
--  BaudModsPrintAll({GetCursorInfo()});
  DragItem = {String = DragItem, Stack = select(2,GetContainerItemInfo(Bag,Slot)), Origin = (((Bag == -1)or(Bag > 4))and 2 or 1)};
  BaudManifestShowDragCount();
  DebugMsg("Item pickup from "..Bag..", "..Slot);
end);


--This function is used when dragging items onto the vendor window.  The values passed to it don't matter in this case.
hooksecurefunc("PickupMerchantItem",function()
  DebugMsg("Pickup merchant item");
end);


function BaudManifestDragCount_OnUpdate()
  local X, Y = GetCursorPosition();
  this:ClearAllPoints();
  this:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",X + 1,Y - 24);
end


function BaudManifestDragCategoryIcon_OnUpdate()
  this:ClearAllPoints();
  this:SetPoint("BOTTOMRIGHT",UIParent,"BOTTOMLEFT",GetCursorPosition());
end


function BaudManifestDragCategoryClickBlock_OnClick()
  if(arg1=="RightButton")then
    BaudManifestClearDragCategory();
  else
    StaticPopup_Show("BAUDMANIFEST_DELETECATEGORY");
  end
end


function BaudManifestShowDragCount()
  if not CursorHasItem()or(select(8,GetItemInfo(DragItem.String))==1)then
    return;
  end
  local Count = DragItem.Stack;
  if DragItem.Remain then
    Count = Count + DragItem.Remain;
  end
  BaudManifestDragCountText:SetText(Count);
  DebugMsg("Showing drag count of "..Count);
  BaudManifestDragCount:Show();
end


function BaudManifest_OnHotkeyPressed()
  --[[ChatFrame1:AddMessage("Item is: "..(select(3,GetContainerItemInfo(0,1))and "locked" or "unlocked"));
  UseContainerItem(0,1);
  ChatFrame1:AddMessage("Item is: "..(select(3,GetContainerItemInfo(0,1))and "locked" or "unlocked"));]]


  if BaudManifestDisplay1:IsShown()then
    BaudManifestDisplay1:Hide();
  else
    BaudManifestDisplay1:Show();
  end
end


function BaudManifestBagPriority(Bag,ItemString)
  --nil - Item cannot go in this bag, 0 - Unknown, 1 - Any item could go here, 2 - This bag is specificly for this item type
  if(Bag < 1)then
    return 1;
  end
  local BagType = GetInventoryItemLink("player",ContainerIDToInventoryID(Bag));
  if not BagType then
    return;
  end
  BagType = select(7, GetItemInfo(BagType));
  if not BagType then
    return;
  end
  if(BagType=="Bag")then
    return 1;
  elseif not SpecialBags[BagType]or not ItemString then
    return 0;
  end
  local ItemType = select(7, GetItemInfo(ItemString));
  if not ItemType then
    return;
  end
  for Key, Value in ipairs(SpecialBags[BagType])do
    if(Value==ItemType)then
      return 2;
    end
  end
  return;
end


function BaudManifestTradeRemain()
  if TradeOpen then
    IgnoreHooks = true;
    DropItemOnUnit("NPC");
    IgnoreHooks = false;
    return true;
  end
  return false;
end


hooksecurefunc("DropItemOnUnit",function(Unit)
  if not IgnoreHooks and TradeOpen and DragItem and DragItem.Remain and UnitIsUnit("NPC",Unit)then
    BaudManifestPickupDragRemain(BaudManifestTradeRemain);
  end
end);


hooksecurefunc("ClickTradeButton",function(Index)
  if TradeOpen and DragItem and DragItem.Remain then
    BaudManifestPickupDragRemain(BaudManifestTradeRemain);
  end
end);


function BaudManifest_OnUpdate()
  if DragItem and not DragItem.Pending and not CursorHasItem()then
    DebugMsg("Clearing dragged item.");
    DragItem = nil;
    BaudManifestDragCount:Hide();
    if CursorHover then
      BaudManifestDropLine:Hide();
    end
  end
  if CursorHover and(DragItem and(CursorHover==DragItem.Origin)or DragCategory and(CursorHover==DragCategory.Origin))then
    local Position, Indent = BaudManifestGetCursorPos(CursorHover);
    local ScrollBar = getglobal("BaudManifestDisplay"..CursorHover.."ScrollBar");
    BaudManifestDropLine:SetPoint("TOP",ScrollBar,"TOP",0,16 * (1-Position)+1);
    BaudManifestDropLine:SetPoint("LEFT",ScrollBar,"LEFT",8 + Indent * IndentSize,0);
    BaudManifestDropLine:SetPoint("RIGHT",ScrollBar,"RIGHT",-8,0);
    BaudManifestDropLine:SetFrameLevel(ScrollBar:GetFrameLevel() + 3);
    BaudManifestDropLine:Show();
  end
  for Display = 1, 2 do
    if QueuedUpdate[Display]then
      QueuedUpdate[Display] = false;
      if DragItem and(DragItem.Pending==1)and(DragItem.Origin==Display)then
        DragItem.Pending = nil;
        --if the split item is picked up immediately, the client will not register that it is locked
        BaudManifestPickupDragRemain();
      end
      BaudManifestUpdateList(Display);
    end
  end
end


function BaudManifestForEachSlot(Display, Func)
  if(Display==1)then
    for Bag = 0, 4 do
      for Slot = 1, GetContainerNumSlots(Bag) do
        if Func(Bag, Slot)then
          return true;
        end
      end
    end
    --Equipped items
    for Slot = 1, 19 do
      if Func(nil, Slot)then
        return true;
      end
    end
  else
    for Slot = 1, GetContainerNumSlots(-1)do
      if Func(-1, Slot)then
        return true;
      end
    end
    for Bag = 5, 4 + GetNumBankSlots() do
      for Slot = 1, GetContainerNumSlots(Bag)do
        if Func(Bag, Slot)then
          return true;
        end
      end
    end
  end
  return false;
end


local function AnchorDropdown(DropDown)
  getglobal(DropDown:GetName().."Middle"):SetPoint("RIGHT",-25,0); --DropDown:GetName().."Right","LEFT"
  getglobal(DropDown:GetName().."Text"):SetPoint("LEFT",DropDown:GetName().."Left","RIGHT",7,0);
  DropDown.noResize = 1;
end


function BaudManifestDisplay_OnLoad()
  this:RegisterForDrag("LeftButton");
  this:RegisterForClicks("LeftButtonUp","RightButtonUp");
  tinsert(UIMenus,this:GetName());

  local DropDown = getglobal(this:GetName().."SortDropDown");
  AnchorDropdown(DropDown);
  UIDropDownMenu_Initialize(DropDown, BaudManifestSortDropDown_Initialize);
  UIDropDownMenu_SetSelectedValue(DropDown, SelectedSort[this:GetID()]);

  local DropDown = getglobal(this:GetName().."FilterDropDown");
  AnchorDropdown(DropDown);
  UIDropDownMenu_Initialize(DropDown, BaudManifestFilterDropDown_Initialize);
  UIDropDownMenu_SetSelectedValue(DropDown, SelectedFilter[this:GetID()]);

  getglobal(this:GetName().."ClickBlock"):SetFrameLevel(this:GetFrameLevel() + 4);
end


function BaudManifestDisplay_OnUpdate()
  if this.Alpha then
    if this.Closing then
      this.Alpha = this.Alpha - (arg1 / FadeTime);
      if(this.Alpha < 0)then
        this.Alpha = nil;
        this:Hide();
        this.Closing = nil;
        return;
      end
    else
      this.Alpha = this.Alpha + (arg1 / FadeTime);
      if(this.Alpha > 1)then
        this:SetAlpha(1);
        this.Alpha = nil;
        return;
      end
    end
    this:SetAlpha(this.Alpha);
  end
end


function BaudManifestDisplay_OnSizeChanged()
  local ScrollBar = getglobal(this:GetName().."ScrollBar");
  local Entries = floor(ScrollBar:GetHeight()/16);
  if(Entries == this.Entries)then
    return;
  end
  local Display = this:GetID();
  this.Entries = Entries;
  local Button;
  if not this.MaxEntries or(this.MaxEntries < Entries)then
    for Index = (this.MaxEntries or 1), Entries do
      Button = CreateFrame("Button",this:GetName().."Entry"..Index,this,"BaudManifestItemEntryTemplate");
      Button:ClearAllPoints();
      Button:SetPoint("TOP",ScrollBar,"TOP",0,16*(1-Index));
      Button:SetPoint("LEFT",ScrollBar);
      Button:SetPoint("RIGHT",ScrollBar);
      Button.Display = Display;
      --This is just to prevent errors from occuring when shift clicking to split stacks
      Button.count = 0;
    end
    this.MaxEntries = Entries;
  else
    for Index = Entries, this.MaxEntries do
      getglobal(this:GetName().."Entry"..Index):Hide();
    end
  end
  BaudManifestScrollBar_Update(Display)
end


function BaudManifestDisplay_OnShow()
  if this.Closing then
    return;
  end
  PlaySound("igBackPackOpen");
  this.Alpha = 0;
  this.Closing = false;
  local Display = this:GetID();
  --Remove list items that are no longer exist
  local Index;
  for Category, Value in ipairs(ItemList[Display])do
    Index = 1;
    while(Value[Index])do
      if(Value[Index].Count==0)and not Value[Index].Hide then
        if(Category == 1)then
          tremove(Value,Index);
          Index = Index - 1;
        else
          Value[Index].Hide = true;
        end
      end
      Index = Index + 1;
    end
  end
  BaudManifestUpdateDisplayList(Display);
end


function BaudManifestDisplay_OnHide()
  if this.Closing then
    if this.Alpha then
      this:Show();
    end
    return;
  end
  this.Alpha = 1;
  this.Closing = true;
  this:Show();
  PlaySound("igBackPackClose");
  if(this:GetID()==2)and BankOpen then
    CloseBankFrame();
  end
end


function BaudManifestDisplay_OnClick(Display)
  DebugMsg("Click on "..this:GetName());
  if(BaudManifestCategoryEditBox.Display==Display)then
    BaudManifestCategoryEditBox:Hide();
  end
  if(arg1=="RightButton")then
    BaudManifestClearDragCategory();
    return;
  end
  BaudManifestDropItem(Display);
end


function BaudManifestDisplay_OnDragStart()
  this:StartMoving();
end


function BaudManifestDisplay_OnDragStop()
  this:StopMovingOrSizing();
end


function BaudManifestDisplay_OnEnter(Display)
  CursorHover = Display;
end


function BaudManifestDisplay_OnLeave()
  BaudManifestDropLine:Hide();
  CursorHover = nil;
end


function BaudManifestResize()
  local AnchorPoint = strupper(strsub(this:GetName(),strlen(this:GetParent():GetName().."Resize")+1));
  this:GetParent():StartSizing(AnchorPoint);
end


function BaudManifestStopResize()
  this:GetParent():StopMovingOrSizing();
end


function BaudManifestItemEntry_OnLoad()
  this:RegisterForClicks("LeftButtonUp","RightButtonUp");
  this:RegisterForDrag("LeftButton");
  local Cooldown = getglobal(this:GetName().."Cooldown");
  local Texture = getglobal(this:GetName().."Texture");
  Cooldown:ClearAllPoints();
  Cooldown:SetPoint("TOPLEFT",Texture);
  Cooldown:SetPoint("BOTTOMRIGHT",Texture);
end


--this function is no longer used
--[[function BaudManifestItemEntry_OnClick()
  local Display = this:GetParent():GetParent():GetID();
  if IsShiftKeyDown()and ChatEdit_InsertLink(select(2,GetItemInfo(ItemList[Display][this.ListIndex].ItemString)))then
    return;
  end

  if(Display==2)and not BankOpen then
    return;
  end

  if BaudManifestDropItem(Display)then
    return;
  end
  if(arg1=="RightButton")then
    local ItemString = ItemList[Display][this.ListIndex].ItemString;
    BaudManifestForEachSlot(Display,
      function(Bag, Slot)
        if strfind(GetContainerItemLink(Bag,Slot)or "",ItemString)and not(select(3,GetContainerItemInfo(Bag,Slot)))then
          UseContainerItem(Bag, Slot);
          return true;
        end
      end
    );
  end
end]]


function BaudManifestItemEntry_OnEnter(Button)
  local Display = Button.Display;
  local ItemInfo = ItemList[Display][Button.Category][Button.ItemIndex];
  if not ItemInfo.ItemString then
    DebugMsg("Error: Button is not an item");
    return;
  end
  GameTooltip:SetOwner(Button, "ANCHOR_TOPLEFT");
  ResetCursor();
  Button.updateTooltip = nil;
  if(Display==2)and not BankOpen or not ItemInfo.Slot then
    GameTooltip:SetHyperlink(ItemInfo.ItemString..":"..(ItemInfo.SuffixFactor or 0));

  elseif(ItemInfo.Bag==-1)then
    GameTooltip:SetInventoryItem("player",39 + ItemInfo.Slot);

  elseif not ItemInfo.Bag then
    GameTooltip:SetInventoryItem("player",ItemInfo.Slot);
    
  else
--    ContainerFrameItemButton_OnEnter(Button);
    local HasCooldown, RepairCost = GameTooltip:SetBagItem(ItemInfo.Bag,ItemInfo.Slot);
    
--[[    if ( HasCooldown ) then
      button.updateTooltip = TOOLTIP_UPDATE_TIME;
    else
      button.updateTooltip = nil;
    end]]
  
    if InRepairMode()and RepairCost and(RepairCost > 0)then
      GameTooltip:AddLine(REPAIR_COST, "", 1, 1, 1);
      SetTooltipMoney(GameTooltip, RepairCost);
      GameTooltip:Show();
    elseif IsControlKeyDown()then
      ShowInspectCursor();
    elseif(MerchantFrame:IsShown()and MerchantFrame.selectedTab == 1)then
      ShowContainerSellCursor(ItemInfo.Bag,ItemInfo.Slot);
--[[    elseif ( this.readable ) then
      ShowInspectCursor();]]
    else
      ResetCursor();
    end
  end
end


function BaudManifestSplitStackHandler(Button, Split)
  DragItem = {String = SplitItem, Origin = SplitOrigin, Remain = Split};
  BaudManifestPickupDragRemain();
end


function BaudManifestPickupDragRemain(DropFunc)
  if not DragItem.Remain then
    return;
  end
  if DropFunc then
    DragItem.DropFunc = DropFunc;
  end
  local BestBag, BestSlot, BestCount, EmptyBag, EmptySlot;
  local Link, Count, Locked;
  local ItemString = DragItem.String;
  while true do
    if CursorHasItem()then
      DragItem.Remain = nil;
      DebugMsg("PickupDragRemain:  Cursor has item already - aborting.");
      return;
    end
    if DragItem.MoveDisplay and not BankOpen then
      DragItem = nil;
      DebugMsg("PickupDragRemain:  Bank is not open - aborting.");
      return;
    end
    EmptySlot = nil;
    BaudManifestForEachSlot(DragItem.Origin,function(Bag, Slot)
      if Bag then
        Link = GetContainerItemLink(Bag,Slot);
        _, Count, Locked = GetContainerItemInfo(Bag, Slot);
      else
        Link = GetInventoryItemLink("player",Slot);
        --Set count to zero so that items in your pack will be picked up before ones being worn, except when ctrl is being held
        Count = GetInventoryItemCount("player",Slot);
        Locked = IsInventoryItemLocked(Slot);
      end
      if Link then
        if not Locked and strfind(Link,ItemString,0,true)and(not BestBag or(BestCount < DragItem.Remain)and(Count > BestCount)or(BestCount > DragItem.Remain)and(Count >= DragItem.Remain)and(Count < BestCount))then
          BestBag, BestSlot, BestCount = Bag, Slot, Count;
        end
      elseif Bag and not EmptyBag then
        EmptyBag, EmptySlot = Bag, Slot;
      end
    end);
    if not BestSlot then
      DebugMsg("Could not find item for drag - aborting.");
      DragItem.Remain = nil;
      return;
    end
    if(BestCount <= DragItem.Remain)then
      if not BestBag then
        IgnoreHooks = true;
        PickupInventoryItem(BestSlot);
        IgnoreHooks = false;
      elseif DragItem.MoveDisplay then
        UseContainerItem(BestBag, BestSlot);
      else
        IgnoreHooks = true;
        PickupContainerItem(BestBag, BestSlot);
        IgnoreHooks = false;
      end
      DragItem.Stack = BestCount;
      DragItem.Remain = DragItem.Remain - BestCount;
      DebugMsg("Picking up stack of "..BestCount.." from "..BestBag..","..BestSlot.." ("..DragItem.Remain.." remain)");
      if(DragItem.Remain <= 0)then
        DragItem.Remain = nil;
      end
    else
      DebugMsg("Splitting "..DragItem.Remain.." from stack at "..BestBag..","..BestSlot);
      IgnoreHooks = true;
      SplitContainerItem(BestBag, BestSlot, DragItem.Remain);
      IgnoreHooks = false;
      if EmptyBag and CursorHasItem()then
        DebugMsg("Placing split item at "..EmptyBag..","..EmptySlot);
        DragItem.Pending = true;
        IgnoreHooks = true;
        PickupContainerItem(EmptyBag, EmptySlot);
        IgnoreHooks = false;
        return;
      else
        DragItem.BadSplit = true;
        DragItem.Remain = nil;
      end
    end
    if(not BestBag or not DragItem.MoveDisplay)and not CursorHasItem()then
      DebugMsg("Item move failed - aborting.");
      DragItem = nil;
      return;
    end
    if not DragItem.MoveDisplay and(not DragItem.DropFunc or not DragItem.DropFunc())or not DragItem.Remain then
      BaudManifestShowDragCount();
      return;
    end

  end
end


function BaudManifestItemEntry_OnDragStart()
  local Display = this.Display;
  if(Display==2)and not BankOpen then
    return;
  end
  if BaudManifestDropItem(Display)then
    return;
  end
  local ItemInfo = ItemList[Display][this.Category][this.ItemIndex];

  if(ItemInfo.Count > 1)and(IsShiftKeyDown()or IsAltKeyDown())then
    SplitItem = ItemInfo.ItemString;
    SplitOrigin = Display;
    if IsShiftKeyDown()and IsControlKeyDown()then
      BaudManifestSplitStackHandler(nil,ItemInfo.Count);
    elseif IsAltKeyDown()then
      BaudManifestSplitStackHandler(nil,1);
    else
      this.SplitStack = BaudManifestSplitStackHandler;
      OpenStackSplitFrame(ItemInfo.Count, this, "BOTTOMRIGHT", "TOPRIGHT");
    end
    return;
  end
  local ItemString = ItemInfo.ItemString;
  DebugMsg("Searching for "..ItemString);
  local Smallest = IsControlKeyDown();
  local BestBag, BestSlot, BestStack, Count, Locked, Link;
  BaudManifestForEachSlot(Display,
    function(Bag, Slot)
      if Bag then
        Link = GetContainerItemLink(Bag,Slot);
        _, Count, Locked = GetContainerItemInfo(Bag,Slot);
      else
        Link = GetInventoryItemLink("player",Slot);
        Count = GetInventoryItemCount("player",Slot);
        Locked = IsInventoryItemLocked(Slot);
      end
      if Link and strfind(Link,ItemString,0,true)then
        if not Locked and(Bag or not BestBag)and(not BestBag or Smallest and(Count < BestStack)or not Smallest and(Count > BestStack))then
          BestBag, BestSlot, BestStack = Bag, Slot, Count;
        else
          DebugMsg("Found match, but is locked or not as good.");
        end
      end
    end
  );
  if not BestStack then
    DebugMsg("Failed to find dragged item.");
    return;
  end
  if BestBag then
    --Drag item will automaticaly be set up since ignore hooks is not set
    PickupContainerItem(BestBag, BestSlot);
  else
    --Equipped items that are dragged from within the list are marked with the origin as the list so that when they are dropped,
    --they will be moved instead of placed in your inventory.  if they are dragged from the paper doll and dropped, they will
    --be unequipped.
    PickupInventoryItem(BestSlot);
    DragItem = {String = ItemString, Stack = GetInventoryItemCount("player",BestSlot), Origin = 1};
    --BaudManifestShowDragCount();
  end
  if CursorHasItem()then
    DebugMsg("Picked up item.");
  else
    DebugMsg("Failed to pickup item.");
  end
end


hooksecurefunc("SplitContainerItem",function(Bag, Slot, Amount)
  if IgnoreHooks then
    return;
  end
  SplitHoldItem = GetContainerItemLink(Bag, Slot);
  if not SplitHoldItem then
    return;
  end
  SplitHoldItem = string.match(SplitHoldItem,ItemStringMatch);
  if not SplitHoldItem then
    return;
  end
  SplitHoldItem = tonumber(SplitHoldItem);
  SplitHoldExpire = GetTime() + 120;
end);


function BaudManifestGetCursorPos(Display)
  local Position = (select(2,GetCursorPosition()) / UIParent:GetScale() - getglobal("BaudManifestDisplay"..Display.."ScrollBar"):GetTop()) / -16 + 1;
  if(Position < 1)then
    Position = 1;
  end
  local Entries = getglobal("BaudManifestDisplay"..Display).Entries;
  if(Position > Entries + 1)then
    Position = Entries + 1;
  end
  local DisplayIndex = floor(Position) + FauxScrollFrame_GetOffset(getglobal("BaudManifestDisplay"..Display.."ScrollBar"));
  local ItemIndex;
  if(DisplayIndex >= getn(DisplayList[Display]) + 1)then
    ItemIndex = getn(ItemList[Display][1]) + 1;
    if(Position > getn(DisplayList[Display]) + 1)then
      Position = getn(DisplayList[Display]) + 1;
    end
    return Position, 0, 1, ItemIndex;
  end
  local DisplayInfo = DisplayList[Display][DisplayIndex];
  ItemIndex = DisplayInfo.Index;
  local ItemInfo = ItemList[Display][DisplayInfo.Category][ItemIndex];
  local Remain = Position % 1;
  if ItemInfo.Category and(Remain > 0.25)and
  ((Remain < 0.75)or DisplayList[Display][DisplayIndex+1]and DisplayList[Display][DisplayIndex+1].Category==ItemInfo.Category)then
    return floor(Position + 1), DisplayInfo.Indent + 1, ItemInfo.Category, 1;

  elseif(Remain >= 0.5)then
    ItemIndex = ItemIndex + 1;
  end
  Position = floor(Position + 0.5);

  return Position, DisplayInfo.Indent, DisplayInfo.Category, ItemIndex;
end


function BaudManifestMoveListItem(Display)
  if(SelectedSort[Display]~=1)then
    UIErrorsFrame:AddMessage("List items cannot be moved while the list is sorted.", 1.0, 0.1, 0.1, 1.0, UIERRORS_HOLD_TIME);
    return;
  end

  local _, _, NewCategory, NewIndex = BaudManifestGetCursorPos(Display);
  DebugMsg("Moving item to category "..NewCategory..", index "..NewIndex);

  local function FindCategory(Source)
    if(Source == NewCategory)then
      return true;
    end
    DebugMsg("Searching category #"..Source);
    for Key, Value in ipairs(ItemList[Display][Source])do
      if Value.Category and FindCategory(Value.Category)then
        return true;
      end
    end
  end

  if DragCategory and FindCategory(DragCategory.Index)then
    UIErrorsFrame:AddMessage("You cannot place a category within itself.", 1.0, 0.1, 0.1, 1.0, UIERRORS_HOLD_TIME);
    return;
  end

  local OldItem;

  local function GetOldItem()
    for Category, Value in ipairs(ItemList[Display])do
      for ItemIndex, Value in ipairs(Value)do
        if DragItem and(DragItem.String==Value.ItemString)or DragCategory and(DragCategory.Index==Value.Category)then
          OldItem = Value;
          tremove(ItemList[Display][Category],ItemIndex);
          if(NewCategory==Category)and(NewIndex > ItemIndex)then
            NewIndex = NewIndex - 1;
          end
          return;
        end
      end
    end
  end
  GetOldItem();

  if not OldItem then
    DebugMsg("Failed to find move item");
    return;
  end

  tinsert(ItemList[Display][NewCategory],NewIndex,OldItem);
  BaudManifestUpdateList(Display);
  return true;
end


function BaudManifestDropItem(Display)
  if not DragCategory and not CursorHasItem()then
    return;
  end

  if DragItem and(DragItem.Origin==Display)or(DragCategory and DragCategory.Origin==Display)then
    --Dragging an item around in its own container will only move the item in the list
    BaudManifestMoveListItem(Display);
    BaudManifestClearDragCategory();
    ClearCursor();
    return true;
  end
  if DragCategory then
    BaudManifestClearDragCategory();
    UIErrorsFrame:AddMessage("Categories cannot be moved between displays.", 1.0, 0.1, 0.1, 1.0, UIERRORS_HOLD_TIME);
    return true;
  end
  if DragItem and not BankOpen then
    return true;
  end
  --Don't forget that when putting multiple items in empty slots, you can't use the same slot twice
  local BestBag, BestSlot, BestPriority, Priority;
  BaudManifestForEachSlot(Display,
    function(Bag, Slot)
      if Bag then
        if(Slot==1)then
          Priority = BaudManifestBagPriority(Bag,select(3,GetCursorInfo()));
        end
        if Priority and(not BestPriority or(Priority > BestPriority))and not GetContainerItemLink(Bag, Slot)then
          BestBag, BestSlot, BestPriority = Bag, Slot, Priority;
        end
      end
    end
  );
  if not BestBag then
    return;
  end

  PickupContainerItem(BestBag, BestSlot);

  if DragItem and DragItem.Remain then
    DragItem.MoveDisplay = true;
    --DragItem.Remain = DragItem.Remain + 20;
    BaudManifestPickupDragRemain();
  end
  return true;
end


function BaudManifestUpdateList(Display)
  if QueuedUpdate[Display]then
    return;
  end
  if(Display==2)and not BankOpen then
    DebugMsg("Not updating the bank box because it is not open.");
    return;
  end
  if SplitHoldItem and(GetTime() > SplitHoldExpire)then
    SplitHoldItem = nil;
  end
  DebugMsg("Updating item list "..Display..".");

  --if the count is cleared here, an error during the update process could cause the count to not increase, and the items could be erased.
  for Category, Value in ipairs(ItemList[Display])do
    for ItemIndex, Value in ipairs(Value)do
      if Value.Slot then
        Value.Slot = nil;
      end
    end
  end
  local Incomplete = {};
  local Empty, Slots = 0, 0;
  local PickupBag, PickupSlot, PlaceBag, PlaceSlot;
  local ItemInfo, Link, ItemString, Suffix, UniqueID, Count, MaxCount, Locked, Found;
  local CountSlots;
  local CursorBusy = GetCursorInfo();
  local AddIndex = 1;

  BaudManifestForEachSlot(Display,
    function(Bag, Slot)
      if(Slot==1)then
        if not Bag then
          CountSlots = false;
        elseif(Bag < 1)then
          CountSlots = true;
        else
          Link = GetInventoryItemLink("player",ContainerIDToInventoryID(Bag));
          CountSlots = Link and(select(7, GetItemInfo(Link))=="Bag");
          --ChatFrame1:AddMessage(select(7, GetItemInfo(Link)));
        end
      end
      if CountSlots then
        Slots = Slots + 1;
      end
      if Bag then
        Link = GetContainerItemLink(Bag, Slot);
        _, Count, Locked = GetContainerItemInfo(Bag, Slot);
      else
        Link = GetInventoryItemLink("player", Slot);
        Count = GetInventoryItemCount("player", Slot);
        Locked = IsInventoryItemLocked(Slot);
      end
      if Link then
        ItemString, Suffix, UniqueID = string.match(Link,ItemStringMatch);
        if ItemString then
          MaxCount = select(8,GetItemInfo(ItemString));
          Found = false;
          for Category, Value in ipairs(ItemList[Display])do
            for ItemIndex, Value in ipairs(Value)do
              if(Value.ItemString==ItemString)then
                if(not Value.Slot or not Value.Equipped)and((Value.Equipped==true)~=(not Bag))then
                  Value.Equipped = not Bag and true or nil;
                end
                if Value.Slot then
                  Value.Count = Value.Count + Count;
                  Value.Stacks = (Value.Stacks or 1) + 1;
                else
                  Value.Count = Count;
                  if Value.Stacks then
                    Value.Stacks = nil;
                  end
                  if Value.Hide then
                    Value.Hide = nil;
                  end
                end

                if not Value.Slot or Bag and not Value.Bag or not Locked and Value.Locked or not Locked and(Count > Value.Stack)then
                  Value.Bag = Bag;
                  Value.Slot = Slot;
                  Value.Stack = Count;
                  Value.Locked = Locked;
                end
                Found = true;
                break;
              end
            end
          end
          if not Found then
            --Without incrementing the index each time, multiple entries added during the same scan would seem backwards
--[[            tinsert(ItemList[Display][1],AddIndex,{ItemString=ItemString,Count=Count,Bag=Bag,Slot=Slot,Locked=Locked,Stack=Count});
            if not Bag then
              ItemList[Display][1][AddIndex].Equipped = true;
            end
            AddIndex = AddIndex + 1;]]
            ItemInfo = {ItemString=ItemString,Count=Count,Bag=Bag,Slot=Slot,Locked=Locked,Stack=Count};
            if not Bag then
              ItemInfo.Equipped = true;
            end
            --When the item suffix is negative, that means there is a scaling factor stored in the first 16 bits of the UniqueID.
            --Without this scaling factor, the item's stats will not display correctly if a tooltip is created from the info.
            if(tonumber(Suffix) < 0)then
              ItemInfo.SuffixFactor = bit.band(tonumber(UniqueID),65535);
            end
            tinsert(ItemList[Display][1],ItemInfo);
          end
          --MaxCount can register nil here
          if Bag and not CursorBusy and MaxCount and(Count < MaxCount)and not Locked and(SplitHoldItem~=ItemString)and(not DragItem or(DragItem.String~=ItemString)or not DragItem.Pending)then
            if not Incomplete[ItemString]then
              Incomplete[ItemString] = {Bag=Bag, Slot=Slot, Count=Count};
            else
              PickupBag, PickupSlot = Bag, Slot;
              PlaceBag, PlaceSlot = Incomplete[ItemString].Bag,Incomplete[ItemString].Slot;
              --Combine two incomplete stacks by moving the larger one onto the smaller
              if(Count < Incomplete[ItemString].Count)then
                PickupBag, PickupSlot, PlaceBag, PlaceSlot = PlaceBag, PlaceSlot, PickupBag, PickupSlot
              end
              Incomplete[ItemString] = nil;
              DebugMsg("Item is "..(Locked and "locked" or "unlocked"));
              ClearCursor();
              DebugMsg("Combining incomplete stacks.");
              IgnoreHooks = true;
              PickupContainerItem(PickupBag, PickupSlot);
              if CursorHasItem()then
                PickupContainerItem(PlaceBag, PlaceSlot);
                ClearCursor();
              end
              IgnoreHooks = false;
            end
          end
        end
      elseif CountSlots then
        Empty = Empty + 1;
      end
    end
  );
  --Set counts of items that were not found to 0.  Safest to be done after, in case of errors occuring, causing the scan process to end prematurely.
  for Category, Value in ipairs(ItemList[Display])do
    for ItemIndex, Value in ipairs(Value)do
      if Value.ItemString and not Value.Slot then
        Value.Count = 0;
        if Value.Stacks then
          Value.Stacks = nil;
        end
      end
    end
  end
  ItemList[Display].SlotEmpty = Empty;
  ItemList[Display].SlotTotal = Slots;
  BaudManifestUpdateDisplayList(Display);
end


function BaudManifestCountCategorySlots(Display)
  DebugMsg("Counting slot usage for all categories.");
  for Key, Value in ipairs(ItemList[Display])do
    Value.SlotsUsed = nil;
  end

  local function CountCategory(Category)
    Category.SlotsUsed = 0;
    local Index = 1;
    while Category[Index]do
      if Category[Index].ItemString and(Category[Index].Count > 0)then
        Category.SlotsUsed = Category.SlotsUsed + (Category[Index].Stacks or 1);
      elseif Category[Index].Category then
        if not ItemList[Display][Category[Index].Category].SlotsUsed then
          Category.SlotsUsed = Category.SlotsUsed + CountCategory(ItemList[Display][Category[Index].Category]);
        else
          DebugMsg("Removing duplicate category entry.");
          tremove(Category,Index);
          Index = Index - 1;
        end
      end
      Index = Index + 1;
    end
    return Category.SlotsUsed;
  end
  CountCategory(ItemList[Display][1]);
  
  local Found;
  for Category, Value in ipairs(ItemList[Display])do
    if not Value.SlotsUsed then
      ChatFrame1:AddMessage("BaudManifest: Found stray category - restoring.");
      Found = true;
      tinsert(ItemList[Display][1],{Category = Category});
    end
  end
  if Found then
    return BaudManifestCountCategorySlots(Display);
  end
end


function BaudManifestCustomFilter(ItemString, Filter)
  if Filter and strfind(Filter,"[^%s]")then
    Filter = strlower(Filter);
    BaudManifestTooltip:SetHyperlink(ItemString);
    BaudManifestTooltip:Show();
    for Index = 1, BaudManifestTooltip:NumLines()do
--      ChatFrame1:AddMessage(getglobal("BaudManifestTooltipTextLeft"..Index):GetText()or "nil");
      if strfind(strlower(getglobal("BaudManifestTooltipTextLeft"..Index):GetText()or ""),Filter,1,true)then
        return true;
      end
      if strfind(strlower(getglobal("BaudManifestTooltipTextRight"..Index):GetText()or ""),Filter,1,true)then
        return true;
      end
    end
    return false;
  end
  return true;
end


function BaudManifestUpdateDisplayList(Display)
  if not getglobal("BaudManifestDisplay"..Display):IsShown()then
    DebugMsg("Not updating display list while the list is closed.");
    return;
  end

  DebugMsg("Generating display list.");
  BaudManifestCountCategorySlots(Display);
  local Sort;
  DisplayList[Display] = {};

  local HideCategories = BaudManifestCategoriesDisabled(Display);

  local function AddCategory(Category, Indent)
    for Key, Value in ipairs(ItemList[Display][Category])do
      if Value.Category then
        if not HideCategories then
          tinsert(DisplayList[Display],{Index = Key, Category = Category, Indent = Indent});
          if ItemList[Display][Value.Category].Expanded then
            AddCategory(Value.Category, Indent + 1);
          end
        else
          AddCategory(Value.Category,0);
        end
      elseif Value.ItemString and not Value.Hide and(BaudManifestCustomFilter(Value.ItemString, CustomFilter[Display])
      and((SelectedFilter[Display]==1)or(SelectedFilter[Display]==select(6,GetItemInfo(Value.ItemString)))))then
        if(SelectedSort[Display]~=1)then
          --Items that enter your backpack which the client has never seen before will not have a lot of GetItemInfo stuff, so
          --unsortable entries will not be shown
          Sort = select(Sorts[SelectedSort[Display]].Var,GetItemInfo(Value.ItemString));
          if Sort then
            tinsert(DisplayList[Display],{Index = Key, Category = Category, Indent = Indent, Sort = Sort});
          end
        else
          tinsert(DisplayList[Display],{Index = Key, Category = Category, Indent = Indent});
        end
      end
    end
  end
  AddCategory(1,0);
  if(SelectedSort[Display]~=1)then
    table.sort(DisplayList[Display],function(a,b) return(a.Sort==b.Sort)and(a.Index < b.Index)or(a.Sort < b.Sort); end);
  end
  DebugMsg("Display list finished.  Updating visual.");
  BaudManifestScrollBar_Update(Display);
end


function BaudManifestScrollBar_Update(Display)
  if not Display then
    Display = this:GetParent():GetID();
  end
  local Frame = getglobal("BaudManifestDisplay"..Display);
  if not Frame:IsShown()or not DisplayList[Display]then
    return;
  end
  if(BaudManifestCategoryEditBox.Display==Display)then
    BaudManifestCategoryEditBox:Hide();
  end
  local Index, Name, Quality, MaxCount, Texture, R, G, B, Text;
  local Button, CategoryFrame, Cooldown, ButtonText, Icon;

  Text = DisplayNames[Display];
  if ItemList[Display].SlotEmpty then
    Text = Text.." ("..ItemList[Display].SlotEmpty.."/"..ItemList[Display].SlotTotal..")";
  end
  getglobal(Frame:GetName().."Text"):SetText(Text);
  local FrameName = Frame:GetName();
  local ScrollBar = getglobal(FrameName.."ScrollBar");
  local Total = getn(DisplayList[Display]);
  FauxScrollFrame_Update(ScrollBar,Total,Frame.Entries,16);
  local ItemInfo;
  for Line = 1, Frame.Entries do
    Index = Line + FauxScrollFrame_GetOffset(ScrollBar);
    Button = getglobal(FrameName.."Entry"..Line);
    if(Index > Total)then
      Button:Hide();
    else
      --The Button.Display value is consistant and is set when the button is made
      Button.ItemIndex = DisplayList[Display][Index].Index;
      Button.Category = DisplayList[Display][Index].Category;
      ItemInfo = ItemList[Display][Button.Category][Button.ItemIndex];
      CategoryFrame = getglobal(Button:GetName().."Category");
      Icon = getglobal(Button:GetName().."Texture");
      Cooldown = getglobal(Button:GetName().."Cooldown");
      ButtonText = getglobal(Button:GetName().."Text");
      ButtonText:Show();
      Button:SetPoint("LEFT",ScrollBar,"LEFT",DisplayList[Display][Index].Indent * IndentSize,0);
      if ItemInfo.ItemString then
        Name, _, Quality, _, _, _, _, MaxCount, _, Texture = GetItemInfo(ItemInfo.ItemString);
        if not Name then
          Button:Hide();
        else
          if ItemInfo.Bag and ItemInfo.Slot then
            Button:SetID(ItemInfo.Slot);
            Button:SetParent(getglobal("BaudManifestBag"..ItemInfo.Bag));
          else
            Button:SetID(0);
            Button:SetParent(getglobal("BaudManifestBag"..((Display==1)and 0 or -1)));
          end
          Cooldown:SetFrameLevel(Button:GetFrameLevel() + 1);
          if ItemInfo.Equipped then
            Name = "E "..Name;
          end
          if(MaxCount > 1)or(ItemInfo.Count~=1)then
            Text = ItemInfo.Count;
            if ItemInfo.Stacks then
              Text = Text.."("..ItemInfo.Stacks..")";
            end
            Name = Text.." "..Name;
          end
          ButtonText:SetText(Name);
          if ItemInfo.Slot then
            R, G, B = GetItemQualityColor(Quality or 1);
            ButtonText:SetTextColor(R, G, B, 1);
            if ItemInfo.Bag then
              ContainerFrame_UpdateCooldown(ItemInfo.Bag,Button);
            else
              Cooldown:Hide();
            end
          else
            ButtonText:SetTextColor(0.2,0.2,0.2,1);
            getglobal(Button:GetName().."Cooldown"):Hide();
          end
          if not ItemInfo.Slot or ItemInfo.Locked or(Display==2)and not BankOpen then
            Icon:SetVertexColor(0.5,0.5,0.5);
          else
            Icon:SetVertexColor(1,1,1);
          end
          Icon:SetTexture(Texture);
          Icon:Show();
          if GameTooltip:IsOwned(Button)then
            BaudManifestItemEntry_OnEnter(Button);
          end
          CategoryFrame:Hide();
          Button:Show();
        end
      else
        CategoryFrame.Category = ItemInfo.Category;
        ButtonText:SetText(ItemList[Display][ItemInfo.Category].Name.." ("..ItemList[Display][ItemInfo.Category].SlotsUsed..")");
        ButtonText:SetTextColor(NORMAL_FONT_COLOR.r,NORMAL_FONT_COLOR.g,NORMAL_FONT_COLOR.b);
        Icon:Hide();
        Cooldown:Hide();
        --Without setting this frame level, the face can fall behind
        CategoryFrame:SetFrameLevel(Button:GetFrameLevel()+1);
--        CategoryFrame:SetChecked(ItemInfo.Expanded);
        Text = ItemList[Display][ItemInfo.Category].Expanded and "Minus" or "Plus";
        CategoryFrame:SetNormalTexture("Interface\\Buttons\\UI-"..Text.."Button-Up");
        CategoryFrame:SetPushedTexture("Interface\\Buttons\\UI-"..Text.."Button-Down");
        CategoryFrame:Show();
        Button:Show();
      end
    end
  end
end


function BaudManifestCategoryEntry_OnLoad()
  this:RegisterForClicks("LeftButtonUp","RightButtonUp");
  this:RegisterForDrag("LeftButton");
end


function BaudManifestCategoryEntry_OnClick()
  local Display = this:GetParent().Display;
  local Category = this.Category;
  if(arg1=="RightButton")then
    DebugMsg("Edit category name");
    local Text = getglobal(this:GetParent():GetName().."Text");
    Text:Hide();
    --Unless the parent is set, the edit box can fall behind the frame
    BaudManifestCategoryEditBox:SetParent(this);
    BaudManifestCategoryEditBox:SetFrameLevel(this:GetFrameLevel() + 1);
    BaudManifestCategoryEditBox:SetPoint("LEFT",Text);
    BaudManifestCategoryEditBox:SetPoint("RIGHT",Text);
    BaudManifestCategoryEditBox.Display = Display;
    BaudManifestCategoryEditBox.Category = Category;
    BaudManifestCategoryEditBox:SetText(ItemList[Display][Category].Name);
    BaudManifestCategoryEditBox:Show();
  else
    DebugMsg("Edit category toggle expand");
    ItemList[Display][Category].Expanded = not ItemList[Display][Category].Expanded;
    BaudManifestUpdateDisplayList(Display);
  end
end


function BaudManifestCategoryEntry_OnDragStart()
  --Can't drag this while you already have a category in your cursor due to the click block
  PlaySound("INTERFACESOUND_CURSORGRABOBJECT");
  DragCategory = {Index = this.Category, Origin = this:GetParent().Display};
  BaudManifestDragCategoryIcon:Show();
  BaudManifestUpdateBlocked();
end


function BaudManifestCategoryEntry_OnDragStop()
  --BaudManifestReleaseCategory();
end


function BaudManifestSortDropDown_Initialize()
  local info = UIDropDownMenu_CreateInfo();
  info.func = BaudManifestSortDropDown_OnClick;
  info.arg1 = getglobal(UIDROPDOWNMENU_INIT_MENU):GetParent():GetID();

  for Key, Value in ipairs(Sorts)do
    info.text = Value.Name;
    info.value = Key;
    info.checked = (info.value == SelectedSort)and 1 or nil;
    UIDropDownMenu_AddButton(info);
  end
end


function BaudManifestSortDropDown_OnClick(Display)
  SelectedSort[Display] = this.value;
  UIDropDownMenu_SetSelectedValue(getglobal("BaudManifestDisplay"..Display.."SortDropDown"), this.value);
  BaudManifestUpdateDisplayList(Display);
end


function BaudManifestFilterDropDown_Initialize()
  local info = UIDropDownMenu_CreateInfo();
  info.func = BaudManifestFilterDropDown_OnClick;
  local Display = getglobal(UIDROPDOWNMENU_INIT_MENU):GetParent():GetID();
  info.arg1 = Display;

  info.text = "No Filter";
  info.value = 1;
  info.checked = (info.value == SelectedFilter[Display])and 1 or nil;
  UIDropDownMenu_AddButton(info);

  --This function gets run before the variables are loaded, this safeguards against errors
  if not ItemList then
    return;
  end

  local ItemTypes = {};
  local Type;
  for Category, Value in ipairs(ItemList[Display])do
    for ItemIndex, Value in ipairs(Value)do
      if Value.ItemString then
        Type = select(6,GetItemInfo(Value.ItemString));
        for Key, Value in ipairs(ItemTypes)do
          if(Type==Value)then
            Type = nil;
            break;
          end
        end
        if Type then
          tinsert(ItemTypes,Type);
        end
      end
    end
  end

  table.sort(ItemTypes,function(a,b) return (a < b);end);

  for Key, Value in ipairs(ItemTypes)do
    info.text = Value;
    info.value = Value;
    info.checked = (info.value == SelectedFilter[Display])and 1 or nil;
    UIDropDownMenu_AddButton(info);
  end
end


function BaudManifestFilterDropDown_OnClick(Display)
  SelectedFilter[Display] = this.value;
  UIDropDownMenu_SetSelectedValue(getglobal("BaudManifestDisplay"..Display.."FilterDropDown"), this.value);
  BaudManifestUpdateDisplayList(Display);
end


function BaudManifestFilterEditBox_OnTextChanged()
  local Display = this:GetParent():GetID();
  CustomFilter[Display] = this:GetText();
  BaudManifestUpdateDisplayList(Display);
end